/*
  Name: DL programowanie zadanie 15 z rozdziau 16 ksiki Thinking in C++
  Author: Piotr Leo
  Date: 27-06-06 19:28
  Description:
Z. 6 rozdzial 15 TICPP
Utwrz hierarchi dziedziczenia klasy Rodent (gryzo): Mouse (mysz),
Gerbil (myszoskoczek), Hamster (chomik) itd. W klasie podstawowej
utwrz funkcje, ktre s wsplne dla wszystkich gryzoni i przedefiniuj je
w klasach pochodnych, umoliwiajc rne zachowania, w zalenoci
od konkretnego typu pochodnego klasy Rodent. Utwrz tablic wskanikw
do obiektw klasy Rodent, wypenij j wskanikami do obiektw
poszczeglnych klas pochodnych, a nastpnie wywoaj funkcje, zawarte
w klasie podstawowej, obserwujc, co si stanie.
Z. 9 rozdzial 15 TICPP
Rozpoczynajc od utworzonej poprzednio hierarchii Rodent, dodaj niewirtualny
destruktor, utwrz obiekt klasy Hamster, uywajc do tego operatora new.
Nastpnie dokonaj rzutowania uzyskanego wskanika na typ Rodent*, a potem
usu wskazywany obiekt za pomoc delete, by pokaza, e nie spowoduje to
wywoania wszystkich destruktorw znajdujcych si w hierarchii. Zamie
destruktor na wirtualny i poka, e wszystko dziaa teraz prawidowo.
Z. 10 rozdzial 15 TICPP
Rozpoczynajc od utworzonej poprzednio hierarchii Rodent, zmodyfikuj
klas Rodent, by bya czysto abstrakcyjn klas podstawow.
*/

#include <iostream>

using namespace std;

class Rodent
{
      public:
             virtual void ile_lap() {cout<<"\tMam 4 lapy"<<endl;}
             virtual void zyje()=0;               //metoda czysto wirtualna!, wiec klasa jest czysto abstakcyjna klasa podstawowa!
             virtual void ludzie() {cout<<"\tLudzie nie lubia gryzoni!"<<endl;} //funkcja wirtualna
             virtual ~Rodent() {cout<<"Uruchomiony destruktor klasy Rodent!"<<endl;} //niewirtualny destruktor
             //~Rodent() {cout<<"Uruchomiony destruktor klasy Rodent!"<<endl;}
};

class Mouse : public Rodent
{
      public:
             void zyje() {cout<<"\tJestem prawie udomowiona ;)"<<endl;}
             void ludzie() {cout<<"\tLudzie mnie nie lubia! :("<<endl;}
             ~Mouse() {cout<<"\tUruchomiony destruktor klasy Mouse!"<<endl;}
             
};

class Gerbil : public Rodent
{
      public:
             void zyje() {cout<<"\tLudzie nie wiedza jak wygladam"<<endl;}
             void ludzie() {cout<<"\tAle i tak mnie tepia"<<endl;}
             ~Gerbil() {cout<<"\tUrochomiony destruktor klasy Gerbil!"<<endl;}
};

class Hamster : public Rodent
{
      public:
              void zyje() {cout<<"\tCzesto robie za zwierzatko domowe"<<endl;}
              void ludzie() {cout<<"\tWiekszosc ludzi mnie lubi"<<endl;}
              ~Hamster() {cout<<"\tUruchomiony destruktor klasy Hamster!"<<endl;}
};

int main()
{
    Rodent (* tab_wsk_o_R[4]);               //tworzymy tablice wskaznikow na obiekty klasy Rodent
    tab_wsk_o_R[0]=new Mouse;                 //tworzymy nowy obiekt i wstawiamy wskaznik na niego do wczesniej utworzonej tablicy
    tab_wsk_o_R[1]=new Gerbil;                //j.w
    tab_wsk_o_R[2]=new Hamster;               //jw.
    //tab_wsk_o_R[3]=new Rodent;              //nie mozemy utworzyc obiektu klasy Rodent, poniewaz jest to klasa abstrakcyjna - metoda zyje() jest czysto wirtualna!
    cout<<"Mysz:"<<endl;                      
    tab_wsk_o_R[0]->zyje();                   //wywolujemy funkcje z pierwszego 
    tab_wsk_o_R[0]->ludzie();
    tab_wsk_o_R[0]->ile_lap();
    cout<<"Myszoskoczek:"<<endl;
    tab_wsk_o_R[1]->zyje();
    tab_wsk_o_R[1]->ludzie();
    tab_wsk_o_R[1]->ile_lap();
    cout<<"Chomik:"<<endl;
    tab_wsk_o_R[2]->zyje();
    tab_wsk_o_R[2]->ludzie();
    tab_wsk_o_R[2]->ile_lap();
    cout<<endl<<endl;
    
    Rodent* a=new Hamster;                    //wywoluje tylko destruktor z klasy glownej (tj. Rodent) jesli destruktor jest niewirtualny
    delete a;                                 //jesli destruktor jest wirtualny, wysolane zostana destruktory z klasy Hamster oraz Rodent
    
    //for(int i=0;i<3;i++)                    //usuwamy wszyskie utworzone obiekty z tablicy tab_wsk_o_R
    //{
    //delete tab_wsk_o_R[i];
    //}
    system("pause");
    return 0;
}
